#ifndef _PY_H_
#define _PY_H_


#define BEGIN_REG() 	methods.clear() 
#define REGISTER(x,y) 	RegisterMethod(x,y) 
#define END_REG() \
		do	{ \
			PyMethodDef __tmp = {NULL, NULL, 0, NULL};\
			methods.push_back(__tmp);\
		}while(0)	


class PyModule 
{
	public:

		typedef PyObject *(*PyCallback )(PyObject *, PyObject *);
		
		PyModule							(const char *n): m_Name(n) {	  }
		virtual			    ~PyModule		();
		PyMethodDef*		 Methods		() {	return &(methods[0]);	}
		const std::string&   Name			() const    {	return m_Name; 			}
		void			     RegisterMethod	(const char *, PyCallback );
		
	protected:

		std::vector <PyMethodDef> methods;
		std::string				  m_Name;
	
		
};

class PyVM
{
	public:
		
						PyVM		(): m_init(false) {	}
		virtual		   ~PyVM		() { 	End();		}
		void			End			() {	if(ok()){ Py_Finalize(); m_init = false;}	}
		inline bool		ok			() const { return m_init;	}

		bool			Init		(const char *);	
		bool			ExecString	(const char *);
		bool			ExecFile	(char *);
		bool			RegiterMod	(PyModule &);
		

	private:

		bool				 m_init;
		std::list<PyModule*> ModList;

};

#endif // ~ _PY_H_